/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseEnemy = (function (_super) {
    __extends(BaseEnemy, _super);
    function BaseEnemy() {
        _super.apply(this, arguments);
    }
    BaseEnemy.prototype.gotEaten = function () {
        this.kill();
    };
    return BaseEnemy;
})(Phaser.Sprite);

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
/// <reference path="./sequential_frame_order_generater.ts" />
/// <reference path="./base_enemy.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Bat = (function (_super) {
    __extends(Bat, _super);
    function Bat(game, x, y) {
        _super.call(this, game, x, y, 'bat');
        this.isDisable = false;
        this.flying = false;
        this.width = 80;
        this.height = 80;
        this.animations.add('fly', new SequentialFrameOrderGenerater().generate(0, 1), 8, true);
        this.animations.add('idle', new SequentialFrameOrderGenerater().generate(2, 0), 1);
        game.physics.enable(this, Phaser.Physics.ARCADE);
        this.animations.play('fly');
        this.soundHit = this.game.add.audio('enemyHit');
    }
    Bat.prototype.idle = function () {
        this.animations.play('idle');
        if (this.flyingTween != null) {
            this.flyingTween.pause();
        }
    };
    Bat.prototype.fall = function () {
        this.fallTween = this.game.add.tween(this)
            .to({ x: this.x, y: 575 }, 400);
        this.fallTween.start();
        this.soundHit.play();
    };
    Bat.prototype.fly = function () {
        if (!this.flying) {
            var y = 300;
            this.flyingTween = this.game.add.tween(this)
                .to({ x: this.x, y: y })
                .to({ x: this.x - 160, y: y + 120 })
                .to({ x: this.x - 320, y: y })
                .to({ x: this.x - 480, y: y + 120 })
                .to({ x: this.x - 640, y: y })
                .to({ x: this.x - 800, y: y + 120 })
                .to({ x: this.x - 960, y: y })
                .to({ x: this.x - 1120, y: y + 120 });
            this.flyingTween.start();
            this.flying = true;
        }
    };
    Bat.prototype.disable = function () {
        this.isDisable = true;
    };
    return Bat;
})(BaseEnemy);

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BatMemory = (function (_super) {
    __extends(BatMemory, _super);
    function BatMemory(game) {
        _super.call(this, game, 0, 0, 'batmemory');
        this.fixedToCamera = true;
    }
    return BatMemory;
})(Phaser.Sprite);

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Fireball = (function (_super) {
    __extends(Fireball, _super);
    function Fireball(game, x, y, direction) {
        this.direction = direction;
        if (direction == -150) {
            x -= 20;
            _super.call(this, game, x, y, 'fireball');
            this.scale.x = -1;
        }
        else {
            x += 100;
            _super.call(this, game, x, y, 'fireball');
            this.scale.x = 1;
        }
        game.physics.enable(this, Phaser.Physics.ARCADE);
        var walk = this.animations.add('fire');
        this.animations.play('fire', 12, true);
        this.body.allowGravity = false;
        this.soundAttack = this.game.add.audio('attack');
    }
    Fireball.prototype.launch = function () {
        this.body.velocity.x = this.direction * 2;
        this.soundAttack.play();
    };
    return Fireball;
})(Phaser.Sprite);

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
/// <reference path="./sequential_frame_order_generater.ts" />
/// <reference path="./rifle_bullet.ts" />
/// <reference path="./base_enemy.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Guard = (function (_super) {
    __extends(Guard, _super);
    function Guard(game, x, y) {
        var _this = this;
        _super.call(this, game, x, y, 'guard');
        this.playSoundHit = true;
        this.state = 'idle';
        this.anchor.x = 0;
        this.anchor.y = 1;
        this.animations.add('idle', new SequentialFrameOrderGenerater().generate(1, 0), 1, true);
        this.animations.add('stunned', new SequentialFrameOrderGenerater().generate(0, 0), 1, true);
        this.animations.add('shoot', [2, 3, 4], 8, false);
        this.animations.play('idle');
        this.shootTimer = this.game.time.events.loop(3000, function () {
            _this.state = 'shooting';
            _this.animations.play('shoot').onComplete.add(_this.onShootCompleted, _this);
            _this.firedBullets.add(new RifleBullet(_this.game, _this.x, _this.y));
        }, this);
        this.firedBullets = this.game.add.group();
        this.game.physics.enable(this, Phaser.Physics.ARCADE);
        this.body.allowGravity = false;
        this.soundHit = this.game.add.audio('enemyHit');
    }
    Guard.prototype.shoot = function () {
    };
    Guard.prototype.onShootCompleted = function () {
        this.state = 'idle';
        this.animations.play('idle');
    };
    Guard.prototype.gotHit = function () {
        this.state = 'stunned';
        this.animations.play('stunned');
        this.shootTimer.timer.destroy();
        if (this.playSoundHit) {
            this.playSoundHit = false;
            this.soundHit.play();
        }
    };
    return Guard;
})(BaseEnemy);

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var GuardMemory = (function (_super) {
    __extends(GuardMemory, _super);
    function GuardMemory(game) {
        _super.call(this, game, 0, 0, 'guardmemory');
        this.fixedToCamera = true;
    }
    return GuardMemory;
})(Phaser.Sprite);

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
/// <reference path="./sequential_frame_order_generater.ts" />
/// <reference path="./player.ts" />
/// <reference path="./fireball.ts" />
/// <reference path="./bat.ts" />
/// <reference path="./guard.ts" />
/// <reference path="./special_bat.ts" />
/// <reference path="./special_guard.ts" />
document.addEventListener('DOMContentLoaded', function () { return display(); });
var groundLayer;
var game;
var bats;
var fireBall;
var player;
var leftKey;
var rightKey;
var spaceBarKey;
var hitKey;
var died;
var overlay_text;
var enemyGroup;
var guards;
function display() {
    game = new Phaser.Game(1280, 720, Phaser.AUTO, 'robster', {
        preload: preload,
        create: create,
        update: update,
        render: render
    });
}
function preload() {
    game.load.spritesheet('player', 'assets/images/player_sprite.png', 160, 160, 40);
    game.load.spritesheet('bat', 'assets/images/bat_sprite.png', 80, 80, 3);
    game.load.spritesheet('fireball', 'assets/images/fireball_sprite.png', 64, 64, 6);
    game.load.spritesheet('ground', 'assets/images/ground_sprite.png', 80, 80, 1);
    game.load.spritesheet('guard', 'assets/images/guard_sprite.png', 160, 160, 5);
    game.load.spritesheet('riflebullet', 'assets/images/rifle_bullet_sprite.png', 8, 8, 1);
    game.load.spritesheet('batmemory', 'assets/images/bat-memory.png', 724, 443, 1);
    game.load.spritesheet('guardmemory', 'assets/images/uncle-memory.png', 724, 443, 1);
    game.load.image("background", "assets/images/background.png");
    game.load.tilemap('levelMap', "assets/level.json", null, Phaser.Tilemap.TILED_JSON);
    game.load.audio('attack', 'assets/audios/player_attack.wav');
    game.load.audio('die', 'assets/audios/player_die.wav');
    game.load.audio('enemyHit', 'assets/audios/enemy_hit.wav');
}
function create() {
    game.physics.startSystem(Phaser.Physics.ARCADE);
    game.physics.arcade.gravity.y = 600;
    game.world.setBounds(0, 0, 5120, 0);
    var background = game.add.sprite(0, 0, 'background');
    background.fixedToCamera = true;
    this.map = game.add.tilemap('levelMap');
    this.map.addTilesetImage('ground_sprite', 'ground');
    groundLayer = this.map.createLayer('Ground');
    groundLayer.resizeWorld();
    this.map.createLayer('Background');
    this.map.setCollisionBetween(1, 100, true, 'Ground');
    player = new Player(game);
    player.onDead.add(onPlayerDead);
    game.add.existing(player);
    game.camera.follow(player);
    leftKey = game.input.keyboard.addKey(Phaser.Keyboard.LEFT);
    rightKey = game.input.keyboard.addKey(Phaser.Keyboard.RIGHT);
    spaceBarKey = game.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
    spaceBarKey.onUp.add(player.jumpUp, player);
    hitKey = game.input.keyboard.addKey(Phaser.Keyboard.Z);
    hitKey.onUp.add(player.attack, player);
    died = false;
    var style = { font: "bold 32px Arial", fill: "#fff", boundsAlignH: "center", boundsAlignV: "middle" };
    overlay_text = this.game.add.text(0, 0, 'press [jump] to restart', style);
    overlay_text.setTextBounds(0, 100, 1280, 720);
    overlay_text.visible = died;
    overlay_text.fixedToCamera = true;
    enemyGroup = game.add.group();
    batsBorn();
    bats.forEach(function (bat) {
        enemyGroup.add(bat);
    });
    guardsBorn();
    guards.forEach(function (guard) {
        enemyGroup.add(guard);
    });
}
function update() {
    if (leftKey.isDown) {
        player.fireDirection = -150;
        player.moveLeft();
    }
    else if (rightKey.isDown) {
        player.fireDirection = 150;
        player.moveRight();
    }
    else {
        player.idle();
    }
    game.physics.arcade.collide(player, groundLayer);
    game.physics.arcade.collide(enemyGroup, groundLayer);
    if (player.body.velocity.y == 10) {
        player.jumpDown();
    }
    if (spaceBarKey.isDown && player.isDead) {
        game.state.restart();
    }
    guards.forEach(function (guard) {
        var _this = this;
        game.physics.arcade.overlap(player, guard.firedBullets, collisionHandler, null, this);
        game.physics.arcade.overlap(player, guard, guard.gotEaten, null, guard);
        if (guard.state !== 'stunned') {
            // if (guard.x -player.x <= 400 ) {
            //     guard.shoot();
            // }
            player.fireArray.forEach(function (fireBall) {
                game.physics.arcade.overlap(fireBall, guard, fireBallHitGuard, null, _this);
            }, this);
        }
    });
    bats.forEach(function (bat) {
        if (!bat.isDisable) {
            if (bat.x - player.x <= 600) {
                bat.fly();
            }
            game.physics.arcade.overlap(player, bat, collisionHandler, null, this);
            player.fireArray.forEach(function (fireball) {
                game.physics.arcade.overlap(fireball, bat, collisionEnemy, null, this);
            }, this);
        }
        if (bat.isDisable) {
            game.physics.arcade.overlap(player, bat, bat.gotEaten, null, bat);
        }
    });
}
function jumpDownComplete() {
    player.body.allowGravity = false;
    player.idle();
}
function collisionEnemy(fireBall, bat) {
    fireBall.kill();
    bat.disable();
    bat.idle();
    bat.fall();
}
function collisionHandler() {
    player.gotHit();
}
function collisionEat(man, bat) {
    bat.destroy();
}
function fireBallHitGuard(fireBall, guard) {
    fireBall.kill();
    guard.gotHit();
}
function render() {
    // game.debug.body(player);
}
function onPlayerDead() {
    overlay_text.visible = true;
}
function batsBorn() {
    var saveZone = 450;
    var range = (80 * 64) / 6;
    bats = new Array();
    for (var n = 1; n <= 6; n++) {
        bats.push(new Bat(game, saveZone + (range * n), 520));
    }
    bats.push(new SpecialBat(game, 1500, 520));
}
function guardsBorn() {
    var saveZone = 600;
    var range = (80 * 64) / 4;
    guards = new Array();
    for (var n = 1; n < 4; n++) {
        guards.push(new Guard(game, saveZone + (range * n), 640));
    }
    guards.push(new SpecialGuard(game, 2000, 640));
}

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
/// <reference path="./sequential_frame_order_generater.ts" />
/// <reference path="./fireball.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Player = (function (_super) {
    __extends(Player, _super);
    function Player(game) {
        _super.call(this, game, 160, 640, 'player');
        this.stepMove = 2.5;
        this.isDisable = false;
        this.jumpping = false;
        this.isFiring = false;
        this.isDead = false;
        this.isIdling = false;
        this.fireDirection = 150;
        this.animations.add('idle', new SequentialFrameOrderGenerater().generate(0, 0), 1);
        this.animations.add('jumpUp', new SequentialFrameOrderGenerater().generate(0, 4), 5);
        this.animations.add('jumpDown', new SequentialFrameOrderGenerater().generate(5, 3), 3);
        this.animations.add('run', new SequentialFrameOrderGenerater().generate(8, 7), 16);
        this.animations.add('idleAtk', new SequentialFrameOrderGenerater().generate(16, 0), 1);
        this.animations.add('jumpAtk', new SequentialFrameOrderGenerater().generate(17, 7), 8);
        this.animations.add('runAtk', new SequentialFrameOrderGenerater().generate(24, 7), 8);
        this.animations.add('hit', new SequentialFrameOrderGenerater().generate(32, 1), 2);
        this.animations.add('die', new SequentialFrameOrderGenerater().generate(34, 5), 6);
        this.anchor.x = 0;
        this.anchor.y = 1;
        game.physics.enable(this, Phaser.Physics.ARCADE);
        this.fireArray = this.game.add.group();
        this.onDead = new Phaser.Signal();
        this.soundMove = this.game.add.audio('move');
        this.soundDie = this.game.add.audio('die');
    }
    Player.prototype.idle = function () {
        if (this.jumpping) {
            return;
        }
        if (this.isDead) {
            return;
        }
        if (this.isFiring) {
            return;
        }
        this.isIdling = true;
        this.animations.play('idle');
    };
    Player.prototype.moveLeft = function () {
        var _this = this;
        if (this.isDisable) {
            return;
        }
        this.anchor.setTo(0.5, 1);
        this.scale.x = -1;
        this.x = this.x - this.stepMove;
        if (this.jumpping) {
            return;
        }
        this.animations.play('run').onComplete.add(function () {
            _this.idle();
        }, this);
    };
    Player.prototype.moveRight = function () {
        var _this = this;
        if (this.isDisable) {
            return;
        }
        this.anchor.x = 0;
        this.scale.x = 1;
        this.x = this.x + this.stepMove;
        if (this.jumpping) {
            return;
        }
        this.animations.play('run').onComplete.add(function () {
            _this.idle();
        }, this);
    };
    Player.prototype.jumpUp = function () {
        if (this.isDisable) {
            return;
        }
        this.jumpping = true;
        this.body.allowGravity = true;
        this.body.velocity.y = -450;
        this.animations.play('jumpUp');
    };
    Player.prototype.jumpDown = function () {
        this.animations.play('jumpDown').onComplete.add(this.onJumpComplete, this);
    };
    Player.prototype.onJumpComplete = function () {
        this.jumpping = false;
        this.animations.play('idle');
    };
    Player.prototype.attack = function () {
        var _this = this;
        if (this.isFiring) {
            return;
        }
        this.isFiring = true;
        this.idleAtk();
        this.jumpAttack();
        var fireBall = new Fireball(this.game, this.x, (this.y - 130), this.fireDirection);
        this.fireArray.add(fireBall);
        this.game.time.events.add(300, function () {
            _this.isFiring = false;
        }, this);
        fireBall.launch();
    };
    Player.prototype.idleAtk = function () {
        if (this.isFiring && this.jumpping) {
            return;
        }
        this.animations.play('idleAtk').onComplete.add(this.idle, this);
    };
    Player.prototype.jumpAttack = function () {
        if (!this.jumpping) {
            return;
        }
        this.animations.play('jumpAtk').onComplete.add(this.idle, this);
    };
    Player.prototype.disable = function () {
        this.isDisable = true;
    };
    Player.prototype.enable = function () {
        this.isDisable = false;
    };
    Player.prototype.gotHit = function () {
        if (this.isDisable) {
            return;
        }
        this.animations.play('hit');
        this.disable();
        this.game.time.events.add(500, this.dead, this);
        var striking = this.game.add.tween(this);
        striking.to({ x: (this.x - 50) }, 100);
        striking.start();
        var graphics = game.add.graphics(0, 0);
        graphics.beginFill(0xFF0000, 1);
        graphics.drawRect(0, 0, 1280, 720);
        graphics.endFill();
        graphics.fixedToCamera = true;
        var damaged = game.add.tween(graphics);
        damaged.to({ alpha: 0 }, 300, null);
        damaged.start();
    };
    Player.prototype.dead = function () {
        this.soundDie.play();
        this.isDead = true;
        this.animations.play('die').onComplete.add(this.disable, this);
        this.onDead.dispatch();
    };
    return Player;
})(Phaser.Sprite);

/// <reference path="../../bower_components/phaser/typescript/phaser.d.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var RifleBullet = (function (_super) {
    __extends(RifleBullet, _super);
    function RifleBullet(game, x, y) {
        _super.call(this, game, x, (y - 90), 'riflebullet');
        this.scale.setTo(2, 2);
        this.game.physics.enable(this, Phaser.Physics.ARCADE);
        this.body.allowGravity = false;
        this.gotFired();
    }
    RifleBullet.prototype.gotFired = function () {
        this.body.velocity.x = -150;
    };
    return RifleBullet;
})(Phaser.Sprite);

var SequentialFrameOrderGenerater = (function () {
    function SequentialFrameOrderGenerater() {
    }
    SequentialFrameOrderGenerater.prototype.generate = function (start, count) {
        var result = [];
        for (var i = start; i <= start + count; i++) {
            result.push(i);
        }
        return result;
    };
    return SequentialFrameOrderGenerater;
})();

/// <reference path="./bat.ts" />
/// <reference path="./bat_memory.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SpecialBat = (function (_super) {
    __extends(SpecialBat, _super);
    function SpecialBat(game, x, y) {
        _super.call(this, game, x, y);
    }
    SpecialBat.prototype.gotEaten = function () {
        var batMemory = new BatMemory(this.game);
        this.game.add.existing(batMemory);
        this.game.time.events.add(300, function () {
            batMemory.kill();
        }, this);
        _super.prototype.gotEaten.call(this);
    };
    return SpecialBat;
})(Bat);

/// <reference path="./guard.ts" />
/// <reference path="./guard_memory.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SpecialGuard = (function (_super) {
    __extends(SpecialGuard, _super);
    function SpecialGuard() {
        _super.apply(this, arguments);
    }
    SpecialGuard.prototype.gotEaten = function () {
        var guardMemory = new GuardMemory(this.game);
        this.game.add.existing(guardMemory);
        this.game.time.events.add(300, function () {
            guardMemory.kill();
        }, this);
        _super.prototype.gotEaten.call(this);
    };
    return SpecialGuard;
})(Guard);
